From oracle-l-bounce@freelists.org  Fri Mar 19 12:03:12 2004
Return-Path: <oracle-l-bounce@freelists.org>
Received: from air189.startdedicated.com (root@localhost)
 by orafaq.com (8.11.6/8.11.6) with ESMTP id i2JI3Cq18417
 for <oracle-l@orafaq.com>; Fri, 19 Mar 2004 12:03:12 -0600
X-ClientAddr: 206.53.239.180
Received: from turing.freelists.org (freelists-180.iquest.net [206.53.239.180])
 by air189.startdedicated.com (8.11.6/8.11.6) with ESMTP id i2JI33o18396
 for <oracle-l@orafaq.com>; Fri, 19 Mar 2004 12:03:03 -0600
Received: from turing (localhost [127.0.0.1])
 by turing.freelists.org (Avenir Technologies Mail Multiplex) with ESMTP
 id A3090390A68; Fri, 19 Mar 2004 13:01:00 -0500 (EST)
Received: with ECARTIS (v1.0.0; list oracle-l); Fri, 19 Mar 2004 12:59:46 -0500 (EST)
X-Original-To: oracle-l@freelists.org
Delivered-To: oracle-l@freelists.org
Received: from mx10.radisys.com (mx10.radisys.com [206.102.10.36])
 by turing.freelists.org (Avenir Technologies Mail Multiplex) with ESMTP id 98321390063
 for <oracle-l@freelists.org>; Fri, 19 Mar 2004 12:59:45 -0500 (EST)
Received: by mx10.radisys.com (Postfix, from userid 5)
 id 6BF62142DE6; Fri, 19 Mar 2004 10:06:08 -0800 (PST)
Received: from UNKNOWN(206.103.52.194), claiming to be "dcblackberry.radisys.com"
 via SMTP by mx10, id smtpdAAAPRr_I_; Fri Mar 19 10:05:56 2004
To: oracle-l@freelists.org
Subject: RE: Query returning wrong results.
MIME-Version: 1.0
X-Mailer: Lotus Notes Release 5.0.10  March 22, 2002
Message-ID: <OFE0341AF4.20A56B01-ON88256E5C.0063611B-88256E5C.006354B1@radisys.com>
From: Jared.Still@radisys.com
Date: Fri, 19 Mar 2004 10:05:55 -0800
X-MIMETrack: Serialize by Router on DCBlackBerry/Radisys_Corporation/US(Release 6.0.3|September
 26, 2003) at 03/19/2004 10:02:25 AM,
 Serialize complete at 03/19/2004 10:02:25 AM
Content-Type: multipart/alternative; boundary="=_alternative 006354AE88256E5C_="
X-archive-position: 1274
X-ecartis-version: Ecartis v1.0.0
Sender: oracle-l-bounce@freelists.org
Errors-To: oracle-l-bounce@freelists.org
X-original-sender: Jared.Still@radisys.com
Precedence: normal
Reply-To: oracle-l@freelists.org
X-list: oracle-l
--=_alternative 006354AE88256E5C_=
Content-Type: text/plain; charset="us-ascii"

David,

Try running the test from my previous post and check the results.

You should see one row returned.

Jared






david wendelken <davewendelken@earthlink.net>
Sent by: oracle-l-bounce@freelists.org
 03/18/2004 08:38 PM
 Please respond to oracle-l

 
        To:     oracle-l@freelists.org
        cc: 
        Subject:        RE: Query returning wrong results.


It's been a rough two weeks, so I could certainly be wrong on this one.
 
Let's simplify the query to make the problem more visible.
This is from the inline query.
 
select a.col1
from   table1 a
where a.col1   = '10000151'
union all
select a1.col1
from   table1 a1
where  a1.col1   = '10000151'
and    some_other_condition = 'true'
 
So, let's say that there are 100 records in table1.
2 of them have a col1 value of '10000151'.
 
So, part one above would bring back 2 rows.
Part two above would bring back 0, 1, or 2 rows, depending upon whether 
the "some_other_condition" returned true or not.
Agreed?
 
That would mean that the inline query duplicates records, in that it is 
possible for a given row to show up in both parts.
 
Here's a simple way to tell if I'm right.  (My hard disk crashed at home 
earlier this week and I haven't
re-installed oracle yet, or I would test it myself.)
 
Put the primary key columns of the record, plus a data source column into 
the queries, something like this:
select data_source, pkcol, ...
from (select 'part one' data_source, pkcol, ...
         union all
          select 'part two', pkcol,...
         )
 
Hope that explains what I was getting at! :)

-----Original Message----- 
From: Jared.Still@radisys.com 
Sent: Mar 18, 2004 7:58 PM 
To: oracle-l@freelists.org 
Subject: RE: Query returning wrong results. 


> The first part of the subquery would bring back each and every row with 
a col1   = '10000151'


> The second part of the subquery would bring back some of those same rows 
again, but with different date values, thus duplicating some rows in the 
result set.

Not  sure I'm following. 

Using the erroneous test results supplied by the poster, a test query 
simulating 
the table with hard coded data does return the expected results. 


16:55:47 SQL>@j 
16:55:48 SQL> 
16:55:48 SQL> 
16:55:48 SQL>select     v.col1, v.row_eff_date, v.row_term_date 
16:55:48   2  from 
16:55:48   3  (  -- Inline view begins 
16:55:48   4  select 10000151 col1 
16:55:48   5          , to_date('01-jan-1900','dd/mon/yyyy') row_eff_date 
16:55:48   6          , to_date('13-dec-2002','dd/mon/yyyy') row_term_date 

16:55:48   7  from dual 
16:55:48   8  union 
16:55:48   9  select 10000151 col1 
16:55:48  10          , to_date('13-dec- 2002','dd/mon/yyyy') row_eff_date 

16:55:48  11          , to_date('23-jan-2003','dd/mon/yyyy') row_term_date 

16:55:48  12  from dual 
16:55:48  13  union 
16:55:48  14  select 10000151 col1 
16:55:48  15          , to_date('23-jan-2003','dd/mon/yyyy') row_eff_date 
16:55:48  16          , to_date('31-dec-2999','dd/mon/yyyy') row_term_date 

16:55:48  17  from dual 
16:55:48  18  ) v 
16:55:48  19  where 
16:55:48  20  ( 
16:55:48  21          trunc(v.row_eff_date)   > 
to_date('03/14/2004','MM/DD/YYYY')  OR 
16:55:48  22          trunc(v.row_term_date)  = 
to_date('12/31/2999','MM/DD/YYYY') 
16:55:48  23  ) 
16:55:48  24  / 

      COL1 ROW_EFF_DATE        ROW_TERM_DATE 
---------- ------------------- ------------------- 
  10000151 01/23/2003 00:00:00 12/31/2999 00:00:00 

1 row selected. 

16:55:48 SQL> 






david wendelken <davewendelken@earthlink.net> 
Sent by: oracle-l-bounce@freelists.org 
 03/18/2004 04:29 PM 
 Please respond to oracle-l 
        
        To:        oracle-l@freelists.org 
        cc:         
        Subject:        RE: Query returning wrong results.



Actually, the query is doing exactly what you told it to do!

The first part of the subquery would bring back each and every row with a 
col1   = '10000151'
.

The second part of the subquery would bring back some of those same rows 
again, but with different date values, thus duplicating some rows in the 
result set.



-----Original Message-----
From: "Khedr, Waleed" <Waleed.Khedr@FMR.COM>
Sent: Mar 18, 2004 5:38 PM
To: "'oracle-l@freelists.org'" <oracle-l@freelists.org>
Subject: RE: Query returning wrong results.

Is it using PQO?

Waleed

-----Original Message-----
From: Prasada.Gunda@hartfordlife.com
[mailto:Prasada.Gunda@hartfordlife.com]
Sent: Thursday, March 18, 2004 2:32 PM
To: oracle-l@freelists.org
Subject: Query returning wrong results.



Hi,

One of our developer sent me this query that it is returning wrong results 
.
Please see the following query.

select  v.col1, v.row_eff_date, v.row_term_date
from
(  -- Inline view begins
select a.col1
,    trunc(a.col2) row_eff_date
,    nvl(lead(trunc(a.col2)) over
       (partition by a.col1, a.tblnm, a.clmnnm order by a.col2),to_date
('12/31/2999','mm/dd/yyyy')) row_term_date
from   table1 a
where  a.tblnm  = 'INPUT_TABLE'
and    a.clmnnm = 'INPUT_COL'
and    a.col1   = '10000151'
union all
select a1.col1
,    to_date('01/01/1900','mm/dd/yyyy') row_eff_date
,    trunc(a1.col2) row_term_date
from   table1 a1
where  a1.tblnm  = 'INPUT_TABLE'
and    a1.clmnnm = 'INPUT_COL'
and    a1.col1   = '10000151'
and    (a1.col1, a1.col2) IN
               (select octl1.col1, min(octl1.col2) 
                from table1 octl1
                where octl1.tblnm  ='INPUT_TABLE'
                and   octl1.clmnnm ='INPUT_COL'
                group by octl1.col1
                )
-- Inline view ends.
) v
where
(
    trunc(v.row_eff_date)   >  to_date('03/14/2004','MM/DD/YYYY')  OR
    trunc(v.row_term_date)  =  to_date('12/31/2999','MM/DD/YYYY')
)


If I run inline view on its own, it returns 3 records.

COL1         ROW_EFF_DAT ROW_TERM_DA
------------ ----------- -----------
10000151     01-jan-1900 13-dec-2002
10000151     13-dec-2002 23-jan-2003
10000151     23-jan-2003 31-dec-2999

If I run t he entire sql, it suppose to return the following record.

COL1         ROW_EFF_DAT ROW_TERM_DA
------------ ----------- -----------
10000151     23-jan-2003 31-dec-2999

But, the query returns the following two records which is wrong.

COL1         ROW_EFF_DAT ROW_TERM_DA
------------ ----------- -----------
10000151     13-dec-2002 23-jan-2003
10000151     23-jan-2003 31-dec-2999

Did anybody experience this before. I kind of remember that it is 
something
to do with analytical function but I can not recall.
For the purpose of testing, when I created a table out of inner sql and
used that table in the inner query, it works fine. The DB is 8.1.7.4 on
Hp-unix v11.  I also opened a TAR and will update the status to the List.

Thanks in advance. 

Best regards,
Prasad







** ***********************************************************************
PRIVILEGED AND CONFIDENTIAL: This communication, including attachments, is
for the exclusive use of addressee and may contain proprietary, 
confidential
and/or privileged information.  If you are not the intended recipient, any
use, copying, disclosure, dissemination or distribution is strictly
prohibited.  If you are not the intended recipient, please notify the 
sender
immediately by return e-mail, delete this communication and destroy all
copies.
*************************************************************************

----------------------------------------------------------------
Please see the official ORACLE-L FAQ: http://www.orafaq.com
----------------------------------------------------------------
To unsubscribe send email to:  oracle-l-request@freelists.org
put 'unsubscribe' in the subject line.
--
Archives are at http://www.freeli sts.org/archives/oracle-l/
FAQ is at http://www.freelists.org/help/fom-serve/cache/1.html
-----------------------------------------------------------------
----------------------------------------------------------------
Please see the official ORACLE-L FAQ: http://www.orafaq.com
----------------------------------------------------------------
To unsubscribe send email to:  oracle-l-request@freelists.org
put 'unsubscribe' in the subject line.
--
Archives are at http://www.freelists.org/archives/oracle-l/
FAQ is at http://www.freelists.org/help/fom-serve/cache/1.html
-----------------------------------------------------------------

----------------------------------------------------------------
Please see the official ORACLE-L FAQ: http://www.orafaq.com
----------------------------------------------------------------
To unsubscribe send email to:  oracle-l-request@freelists.org
put 'unsubscribe' in the subject lin e.
--
Archives are at http://www.freelists.org/archives/oracle-l/
FAQ is at http://www.freelists.org/help/fom-serve/cache/1.html
-----------------------------------------------------------------


---------------------------------------------------------------- Please 
see the official ORACLE-L FAQ: http://www.orafaq.com ---------------------------------------------------------------- To 
unsubscribe send email to: oracle-l-request@freelists.org put 
'unsubscribe' in the subject line. -- Archives are at http://www.freelists.org/archives/oracle-l/ FAQ is at http://www.freelists.org/help/fom-serve/cache/1.html ----------------------------------------------------------------- 


--=_alternative 006354AE88256E5C_=
Content-Type: text/html; charset="us-ascii"


<br><font size=2 face="sans-serif">David,</font>
<br>
<br><font size=2 face="sans-serif">Try running the test from my previous post and check the results.</font>
<br>
<br><font size=2 face="sans-serif">You should see one row returned.</font>
<br>
<br><font size=2 face="sans-serif">Jared</font>
<br><font size=2 face="sans-serif"><br>
</font>
<br>
<br>
<br>
<table width=100%>
<tr valign=top>
<td>
<td><font size=1 face="sans-serif"><b>david wendelken &lt;davewendelken@earthlink.net&gt;</b></font>
<br><font size=1 face="sans-serif">Sent by: oracle-l-bounce@freelists.org</font>
<p><font size=1 face="sans-serif">&nbsp;03/18/2004 08:38 PM</font>
<br><font size=2 face="sans-serif">&nbsp;</font><font size=1 face="sans-serif">Please respond to oracle-l</font>
<br>
<td><font size=1 face="Arial">&nbsp; &nbsp; &nbsp; &nbsp; </font>
<br><font size=1 face="sans-serif">&nbsp; &nbsp; &nbsp; &nbsp; To: &nbsp; &nbsp; &nbsp; &nbsp;oracle-l@freelists.org</font>
<br><font size=1 face="sans-serif">&nbsp; &nbsp; &nbsp; &nbsp; cc: &nbsp; &nbsp; &nbsp; &nbsp;</font>
<br><font size=1 face="sans-serif">&nbsp; &nbsp; &nbsp; &nbsp; Subject: &nbsp; &nbsp; &nbsp; &nbsp;RE: Query returning wrong results.</font></table>
<br>
<br>
<br><font size=3 face="Times New Roman">It's been a rough two weeks, so I could certainly be wrong on this one.</font>
<br><font size=3 face="Times New Roman">&nbsp;</font>
<br><font size=3 face="Times New Roman">Let's simplify the query to make the problem more visible.</font>
<br><font size=3 face="Times New Roman">This is from the inline query.</font>
<br><font size=3 face="Times New Roman">&nbsp;</font>
<br><font size=3 face="Times New Roman">select a.col1</font>
<br><font size=3 face="Times New Roman">from &nbsp; table1 a<br>
where a.col1 &nbsp; = '10000151'<br>
union all<br>
select a1.col1<br>
from &nbsp; table1 a1<br>
where &nbsp;a1.col1 &nbsp; = '10000151'<br>
and &nbsp; &nbsp;some_other_condition = 'true'</font>
<br><font size=3 face="Times New Roman">&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; <br>
So, let's say that there are 100 records in table1.</font>
<br><font size=3 face="Times New Roman">2 of them have a col1 value of '10000151'.</font>
<br><font size=3 face="Times New Roman">&nbsp;</font>
<br><font size=3 face="Times New Roman">So, part one above would bring back 2 rows.</font>
<br><font size=3 face="Times New Roman">Part two above would bring back 0, 1, or 2 rows, depending upon whether the &quot;some_other_condition&quot; returned true or not.</font>
<br><font size=3 face="Times New Roman">Agreed?</font>
<br><font size=3 face="Times New Roman">&nbsp;</font>
<br><font size=3 face="Times New Roman">That would mean that the inline query duplicates records, in that it is possible for a given row to show up in both parts.</font>
<br><font size=3 face="Times New Roman">&nbsp;</font>
<br><font size=3 face="Times New Roman">Here's a simple way to tell if I'm right. &nbsp;(My hard disk crashed at home earlier this week and I haven't<br>
re-installed oracle yet, or I would test it myself.)</font>
<br><font size=3 face="Times New Roman">&nbsp;</font>
<br><font size=3 face="Times New Roman">Put the primary key columns of the record, plus a data source column into the queries, something like this:</font>
<br><font size=3 face="Times New Roman">select data_source, pkcol, ...</font>
<br><font size=3 face="Times New Roman">from (select 'part one' data_source, pkcol, ...</font>
<br><font size=3 face="Times New Roman">&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;union all</font>
<br><font size=3 face="Times New Roman">&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; select 'part two', pkcol,...</font>
<br><font size=3 face="Times New Roman">&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;)</font>
<br><font size=3 face="Times New Roman">&nbsp;</font>
<br><font size=3 face="Times New Roman">Hope that explains what I was getting at! :)</font>
<br><font size=3 face="Times New Roman"><br>
-----Original Message----- <br>
From: Jared.Still@radisys.com <br>
Sent: Mar 18, 2004 7:58 PM <br>
To: oracle-l@freelists.org <br>
Subject: RE: Query returning wrong results. <br>
<br>
</font><font size=2 face="Courier New"><br>
&gt; The first part of the subquery would bring back each and every row with a col1 &nbsp; = '10000151'<br>
<br>
<br>
&gt; The second part of the subquery would bring back some of those same rows again, but with different date values, thus duplicating some rows in the result set.</font><font size=3 face="Times New Roman"><br>
</font><font size=2 face="sans-serif"><br>
Not &nbsp;sure I'm following.</font><font size=3 face="Times New Roman"> <br>
</font><font size=2 face="sans-serif"><br>
Using the erroneous test results supplied by the poster, a test query simulating</font><font size=3 face="Times New Roman"> </font><font size=2 face="sans-serif"><br>
the table with hard coded data does return the expected results.</font><font size=3 face="Times New Roman"> <br>
<br>
</font><font size=2 face="sans-serif"><br>
16:55:47 SQL&gt;@j</font><font size=3 face="Times New Roman"> </font>
<br><font size=2 face="sans-serif">16:55:48 SQL&gt;</font><font size=3 face="Times New Roman"> </font><font size=2 face="sans-serif"><br>
16:55:48 SQL&gt; <br>
16:55:48 SQL&gt;select &nbsp; &nbsp; v.col1, v.row_eff_date, v.row_term_date <br>
16:55:48 &nbsp; 2 &nbsp;from <br>
16:55:48 &nbsp; 3 &nbsp;( &nbsp;-- Inline view begins <br>
16:55:48 &nbsp; 4 &nbsp;select 10000151 col1 <br>
16:55:48 &nbsp; 5 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;, to_date('01-jan-1900','dd/mon/yyyy') row_eff_date <br>
16:55:48 &nbsp; 6 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;, to_date('13-dec-2002','dd/mon/yyyy') row_term_date <br>
16:55:48 &nbsp; 7 &nbsp;from dual <br>
16:55:48 &nbsp; 8 &nbsp;union <br>
16:55:48 &nbsp; 9 &nbsp;select 10000151 col1 <br>
16:55:48 &nbsp;10 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;, to_date('13-dec- 2002','dd/mon/yyyy') row_eff_date <br>
16:55:48 &nbsp;11 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;, to_date('23-jan-2003','dd/mon/yyyy') row_term_date <br>
16:55:48 &nbsp;12 &nbsp;from dual <br>
16:55:48 &nbsp;13 &nbsp;union <br>
16:55:48 &nbsp;14 &nbsp;select 10000151 col1 <br>
16:55:48 &nbsp;15 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;, to_date('23-jan-2003','dd/mon/yyyy') row_eff_date <br>
16:55:48 &nbsp;16 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;, to_date('31-dec-2999','dd/mon/yyyy') row_term_date <br>
16:55:48 &nbsp;17 &nbsp;from dual <br>
16:55:48 &nbsp;18 &nbsp;) v <br>
16:55:48 &nbsp;19 &nbsp;where <br>
16:55:48 &nbsp;20 &nbsp;( <br>
16:55:48 &nbsp;21 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;trunc(v.row_eff_date) &nbsp; &gt; &nbsp;to_date('03/14/2004','MM/DD/YYYY') &nbsp;OR</font><font size=3 face="Times New Roman"> </font><font size=2 face="sans-serif"><br>
16:55:48 &nbsp;22 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;trunc(v.row_term_date) &nbsp;= &nbsp;to_date('12/31/2999','MM/DD/YYYY')</font><font size=3 face="Times New Roman"> </font><font size=2 face="sans-serif"><br>
16:55:48 &nbsp;23 &nbsp;)</font><font size=3 face="Times New Roman"> </font><font size=2 face="sans-serif"><br>
16:55:48 &nbsp;24 &nbsp;/</font><font size=3 face="Times New Roman"> <br>
</font><font size=2 face="sans-serif"><br>
 &nbsp; &nbsp; &nbsp;COL1 ROW_EFF_DATE &nbsp; &nbsp; &nbsp; &nbsp;ROW_TERM_DATE</font><font size=3 face="Times New Roman"> </font><font size=2 face="sans-serif"><br>
---------- ------------------- -------------------</font><font size=3 face="Times New Roman"> </font><font size=2 face="sans-serif"><br>
 &nbsp;10000151 01/23/2003 00:00:00 12/31/2999 00:00:00</font><font size=3 face="Times New Roman"> <br>
</font><font size=2 face="sans-serif"><br>
1 row selected.</font><font size=3 face="Times New Roman"> <br>
</font><font size=2 face="sans-serif"><br>
16:55:48 SQL&gt;</font><font size=3 face="Times New Roman"> <br>
</font><font size=2 face="sans-serif"><br>
</font><font size=3 face="Times New Roman"><br>
<br>
</font>
<br>
<table width=100%>
<tr valign=top>
<td width=2%>
<td width=52%><font size=1 face="sans-serif"><b>david wendelken &lt;davewendelken@earthlink.net&gt;</b></font><font size=3 face="Times New Roman"> </font><font size=1 face="sans-serif"><br>
Sent by: oracle-l-bounce@freelists.org</font><font size=3 face="Times New Roman"> </font>
<p><font size=1 face="sans-serif">&nbsp;03/18/2004 04:29 PM</font><font size=3 face="Times New Roman"> </font><font size=2 face="sans-serif"><br>
 </font><font size=1 face="sans-serif">Please respond to oracle-l</font><font size=3 face="Times New Roman"> </font>
<td width=44%><font size=1 face="Arial">&nbsp; &nbsp; &nbsp; &nbsp; </font><font size=1 face="sans-serif"><br>
 &nbsp; &nbsp; &nbsp; &nbsp;To: &nbsp; &nbsp; &nbsp; &nbsp;oracle-l@freelists.org</font><font size=3 face="Times New Roman"> </font><font size=1 face="sans-serif"><br>
 &nbsp; &nbsp; &nbsp; &nbsp;cc: &nbsp; &nbsp; &nbsp; &nbsp;</font><font size=3 face="Times New Roman"> </font><font size=1 face="sans-serif"><br>
 &nbsp; &nbsp; &nbsp; &nbsp;Subject: &nbsp; &nbsp; &nbsp; &nbsp;RE: Query returning wrong results.</font></table>
<br>
<br><font size=3 face="Times New Roman"><br>
</font><font size=2 face="Courier New"><br>
Actually, the query is doing exactly what you told it to do!<br>
<br>
The first part of the subquery would bring back each and every row with a col1 &nbsp; = '10000151'<br>
.<br>
<br>
The second part of the subquery would bring back some of those same rows again, but with different date values, thus duplicating some rows in the result set.<br>
<br>
<br>
<br>
-----Original Message-----<br>
From: &quot;Khedr, Waleed&quot; &lt;Waleed.Khedr@FMR.COM&gt;<br>
Sent: Mar 18, 2004 5:38 PM<br>
To: &quot;'oracle-l@freelists.org'&quot; &lt;oracle-l@freelists.org&gt;<br>
Subject: RE: Query returning wrong results.<br>
<br>
Is it using PQO?<br>
<br>
Waleed<br>
<br>
-----Original Message-----<br>
From: Prasada.Gunda@hartfordlife.com<br>
[mailto:Prasada.Gunda@hartfordlife.com]<br>
Sent: Thursday, March 18, 2004 2:32 PM<br>
To: oracle-l@freelists.org<br>
Subject: Query returning wrong results.<br>
<br>
<br>
<br>
Hi,<br>
<br>
One of our developer sent me this query that it is returning wrong results .<br>
Please see the following query.<br>
<br>
select &nbsp;v.col1, v.row_eff_date, v.row_term_date<br>
from<br>
( &nbsp;-- Inline view begins<br>
select a.col1<br>
, &nbsp; &nbsp;trunc(a.col2) row_eff_date<br>
, &nbsp; &nbsp;nvl(lead(trunc(a.col2)) over<br>
 &nbsp; &nbsp; &nbsp; (partition by a.col1, a.tblnm, a.clmnnm order by a.col2),to_date<br>
('12/31/2999','mm/dd/yyyy')) row_term_date<br>
from &nbsp; table1 a<br>
where &nbsp;a.tblnm &nbsp;= 'INPUT_TABLE'<br>
and &nbsp; &nbsp;a.clmnnm = 'INPUT_COL'<br>
and &nbsp; &nbsp;a.col1 &nbsp; = '10000151'<br>
union all<br>
select a1.col1<br>
, &nbsp; &nbsp;to_date('01/01/1900','mm/dd/yyyy') row_eff_date<br>
, &nbsp; &nbsp;trunc(a1.col2) row_term_date<br>
from &nbsp; table1 a1<br>
where &nbsp;a1.tblnm &nbsp;= 'INPUT_TABLE'<br>
and &nbsp; &nbsp;a1.clmnnm = 'INPUT_COL'<br>
and &nbsp; &nbsp;a1.col1 &nbsp; = '10000151'<br>
and &nbsp; &nbsp;(a1.col1, a1.col2) IN<br>
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; (select octl1.col1, min(octl1.col2) <br>
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;from table1 octl1<br>
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;where octl1.tblnm &nbsp;='INPUT_TABLE'<br>
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;and &nbsp; octl1.clmnnm ='INPUT_COL'<br>
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;group by octl1.col1<br>
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;)<br>
-- Inline view ends.<br>
) v<br>
where<br>
(<br>
 &nbsp; &nbsp;trunc(v.row_eff_date) &nbsp; &gt; &nbsp;to_date('03/14/2004','MM/DD/YYYY') &nbsp;OR<br>
 &nbsp; &nbsp;trunc(v.row_term_date) &nbsp;= &nbsp;to_date('12/31/2999','MM/DD/YYYY')<br>
)<br>
<br>
<br>
If I run inline view on its own, it returns 3 records.<br>
</font>
<br><font size=2 face="Courier New">COL1 &nbsp; &nbsp; &nbsp; &nbsp; ROW_EFF_DAT ROW_TERM_DA<br>
------------ ----------- -----------<br>
10000151 &nbsp; &nbsp; 01-jan-1900 13-dec-2002<br>
10000151 &nbsp; &nbsp; 13-dec-2002 23-jan-2003<br>
10000151 &nbsp; &nbsp; 23-jan-2003 31-dec-2999<br>
<br>
If I run t he entire sql, it suppose to return the following record.<br>
<br>
COL1 &nbsp; &nbsp; &nbsp; &nbsp; ROW_EFF_DAT ROW_TERM_DA<br>
------------ ----------- -----------<br>
10000151 &nbsp; &nbsp; 23-jan-2003 31-dec-2999<br>
<br>
But, the query returns the following two records which is wrong.<br>
<br>
COL1 &nbsp; &nbsp; &nbsp; &nbsp; ROW_EFF_DAT ROW_TERM_DA<br>
------------ ----------- -----------<br>
10000151 &nbsp; &nbsp; 13-dec-2002 23-jan-2003<br>
10000151 &nbsp; &nbsp; 23-jan-2003 31-dec-2999<br>
<br>
Did anybody experience this before. I kind of remember that it is something<br>
to do with analytical function but I can not recall.<br>
For the purpose of testing, when I created a table out of inner sql and<br>
used that table in the inner query, it works fine. The DB is 8.1.7.4 on<br>
Hp-unix v11. &nbsp;I also opened a TAR and will update the status to the List.<br>
<br>
Thanks in advance.</font><font size=3 face="Times New Roman"> </font><font size=2 face="Courier New"><br>
<br>
Best regards,<br>
Prasad<br>
<br>
<br>
<br>
<br>
<br>
<br>
<br>
** ***********************************************************************<br>
PRIVILEGED AND CONFIDENTIAL: This communication, including attachments, is<br>
for the exclusive use of addressee and may contain proprietary, confidential<br>
and/or privileged information. &nbsp;If you are not the intended recipient, any<br>
use, copying, disclosure, dissemination or distribution is strictly<br>
prohibited. &nbsp;If you are not the intended recipient, please notify the sender<br>
immediately by return e-mail, delete this communication and destroy all<br>
copies.<br>
*************************************************************************<br>
<br>
----------------------------------------------------------------<br>
Please see the official ORACLE-L FAQ: http://www.orafaq.com<br>
----------------------------------------------------------------<br>
To unsubscribe send email to: &nbsp;oracle-l-request@freelists.org<br>
put 'unsubscribe' in the subject line.<br>
--<br>
Archives are at http://www.freeli sts.org/archives/oracle-l/<br>
FAQ is at http://www.freelists.org/help/fom-serve/cache/1.html<br>
-----------------------------------------------------------------<br>
----------------------------------------------------------------<br>
Please see the official ORACLE-L FAQ: http://www.orafaq.com<br>
----------------------------------------------------------------<br>
To unsubscribe send email to: &nbsp;oracle-l-request@freelists.org<br>
put 'unsubscribe' in the subject line.<br>
--<br>
Archives are at http://www.freelists.org/archives/oracle-l/</font>
<br><font size=2 face="Courier New">FAQ is at http://www.freelists.org/help/fom-serve/cache/1.html<br>
-----------------------------------------------------------------<br>
<br>
----------------------------------------------------------------<br>
Please see the official ORACLE-L FAQ: http://www.orafaq.com<br>
----------------------------------------------------------------<br>
To unsubscribe send email to: &nbsp;oracle-l-request@freelists.org<br>
put 'unsubscribe' in the subject lin e.<br>
--<br>
Archives are at http://www.freelists.org/archives/oracle-l/<br>
FAQ is at http://www.freelists.org/help/fom-serve/cache/1.html<br>
-----------------------------------------------------------------</font><font size=3 face="Times New Roman"><br>
<br>
</font>
<br><font size=3 face="Times New Roman">---------------------------------------------------------------- Please see the official ORACLE-L FAQ: http://www.orafaq.com ---------------------------------------------------------------- To unsubscribe send email to: oracle-l-request@freelists.org put 'unsubscribe' in the subject line. -- Archives are at http://www.freelists.org/archives/oracle-l/ FAQ is at http://www.freelists.org/help/fom-serve/cache/1.html ----------------------------------------------------------------- </font>
<br>
<br>
--=_alternative 006354AE88256E5C_=--
----------------------------------------------------------------
Please see the official ORACLE-L FAQ: http://www.orafaq.com
----------------------------------------------------------------
To unsubscribe send email to:  oracle-l-request@freelists.org
put 'unsubscribe' in the subject line.
--
Archives are at http://www.freelists.org/archives/oracle-l/
FAQ is at http://www.freelists.org/help/fom-serve/cache/1.html
-----------------------------------------------------------------

